library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity VGA_colour is 

port(
    VGA_R,                           -- Red[9:0]
    VGA_G,                           -- Green[9:0]
    VGA_B : out std_logic_vector(9 downto 0); -- Blue[9:0]
	 
	 clk,
	 reset_n : in std_logic;
	 rectangle : in std_logic_vector(3 downto 0);
	 vga_hblank, vga_vblank :in std_logic;
	 
	 pac_fb1,
	 pac_fb2,
	 pac_fb3,
    map_fb	 : in std_logic;
	 
	 ghost_state : in std_logic_vector(1 downto 0)
);
end VGA_colour;
 architecture rtl of VGA_colour is 
 begin
 VideoOut: process (clk, reset_n)
  begin
    if reset_n = '0' then
      VGA_R <= "0000000000";
      VGA_G <= "0000000000";
      VGA_B <= "0000000000";
    elsif clk'event and clk = '1' then
	 if vga_hblank = '0' and vga_vblank ='0' then
      case rectangle is
--***************************************pac_man*****************************
--***************************************************************************	
		  when "0000" =>          
		  if pac_fb1 = '1' then
        VGA_R <= "1111111111";
        VGA_G <= "1111111111";
        VGA_B <= "0000000000";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  end if;
--***************************************pac_2_man***************************
--***************************************************************************	
		  when "1001" =>          
		  if pac_fb1 = '1' then
        VGA_R <= "1111111111";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  end if;		  
--**************************************ghost1*******************************
--***************************************************************************		  
		  when "0001" =>  
		if ghost_state = "01" then 
		  if pac_fb1 = '1' then
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "1111111111";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  end if;
	   elsif ghost_state = "10" then 
		  if pac_fb1 = '1' then
		  VGA_R <= "1111111111";
        VGA_G <= "1111111111";
        VGA_B <= "1111111111";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  end if;
		else         
		  if pac_fb1 = '1' then
		  VGA_R <= "0000000000";
        VGA_G <= "1111111111";
        VGA_B <= "1111111111";
		  elsif pac_fb2 = '1' then 
		  VGA_R <= "0000000000";
        VGA_G <= "1111111111";
        VGA_B <= "1111111111";
		  elsif pac_fb3 = '1' then 
		  VGA_R <= "1111111111";
        VGA_G <= "1111111111";
        VGA_B <= "1111111111";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  end if;
		end if;  
--**************************************ghost2*******************************
--***************************************************************************	
        when "0010" =>
		if ghost_state = "01" then 
		  if pac_fb1 = '1' then
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "1111111111";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  end if;
	   elsif ghost_state = "10" then 
		  if pac_fb1 = '1' then
		  VGA_R <= "1111111111";
        VGA_G <= "1111111111";
        VGA_B <= "1111111111";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  end if;
		else  
	     if pac_fb1 = '1' then
		  VGA_R <= "1111111111";
        VGA_G <= "1010101011";
        VGA_B <= "1010101011";
		  elsif pac_fb2 = '1' then 
		  VGA_R <= "0000000000";
        VGA_G <= "1111111111";
        VGA_B <= "1111111111";
		  elsif pac_fb3 = '1' then 
		  VGA_R <= "1111111111";
        VGA_G <= "1111111111";
        VGA_B <= "1111111111";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
	     end if;
		end if;  
--*************************************ghost3*******************************
--**************************************************************************	
        when "0011" =>
		if ghost_state = "01" then 
		  if pac_fb1 = '1' then
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "1111111111";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  end if;
	   elsif ghost_state = "10" then 
		  if pac_fb1 = '1' then
		  VGA_R <= "1111111111";
        VGA_G <= "1111111111";
        VGA_B <= "1111111111";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  end if;
		else  
	     if pac_fb1 = '1' then
		  VGA_R <= "0000000000";
        VGA_G <= "1111111111";
        VGA_B <= "0000000000";
		  elsif pac_fb2 = '1' then 
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "1111111111";
		  elsif pac_fb3 = '1' then 
		  VGA_R <= "1111111111";
        VGA_G <= "1111111111";
        VGA_B <= "1111111111";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
	     end if;
		end if;  
--************************************wall*********************************
--*************************************************************************
		  when "0101" =>          
		  if map_fb = '1' then
        VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "1111111111";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  end if;
--************************************pea**********************************
--*************************************************************************
		  when "0100" =>          
		  if map_fb = '1' then
        VGA_R <= "1111111111";
        VGA_G <= "1111111111";
        VGA_B <= "1111111111";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  end if;
--*******************************score*number******************************
--*************************************************************************
		  when "0111" =>          
		  if map_fb = '1' then
        VGA_R <= "1111111111";
        VGA_G <= "1111111111";
        VGA_B <= "1111111111";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  end if;
--*************************pac_lives_1*************************************
--*************************************************************************
		  when "1000" =>          
		  if map_fb = '1' then
        VGA_R <= "1111111111";
        VGA_G <= "1111111111";
        VGA_B <= "0000000000";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  end if;
--*************************pac_lives_2*************************************
--*************************************************************************
		  when "1010" =>          
		  if map_fb = '1' then
        VGA_R <= "1111111111";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  else
		  VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  end if;
--*************************************************************************
--*************************************************************************		  
		  when others =>
        VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";
		  end case;
--*************************************************************************
--*************************************************************************	
      else
        VGA_R <= "0000000000";
        VGA_G <= "0000000000";
        VGA_B <= "0000000000";    
      end if;
    end if;
  end process VideoOut;
  end rtl;